Unit AEJ1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAE10_p;

procedure AEJ1R(N :Integer; var A :Array of Real;
                var EV :Array of Real; var V :Array of Real;
                var RAB1 :Array of Real; var IERR :Integer);

implementation

procedure AEJ1R(N :Integer; var A :Array of Real;
                var EV :Array of Real; var V :Array of Real;
                var RAB1 :Array of Real; var IERR :Integer);
var
B,C,E,F,G,H,I,J,K :Integer;
D,L,M,O,P,Q,R,S :Real;
const
SYS051 :Real = 1.192093E-07;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23;
begin
IERR := 0;
for B:=1 to N do
 begin
  for C:=1 to N do
   begin
_1:
    V[(B-1)+(C-1)*N] := 0.0;
   end;
  if ( B = 1 ) 
   then goto _3;
  D := A[(B-1)+0*N]*A[(B-2)+2*N];
  if ( D ) < 0
   then goto _7
   else if ( D ) > 0
         then goto _4
         else goto _2;
_2:
  if ( A[(B-1)+0*N] <> 0.0 ) or ( A[(B-2)+2*N] <> 0.0 ) 
   then goto _8;
  RAB1[B-1] := 0.0;
_3:
  V[(B-1)+(B-1)*N] := 1.0;
  goto _5;
_4:
  RAB1[B-1] := Sqrt(D);
  V[(B-1)+(B-1)*N] := V[(B-2)+(B-2)*N]*RAB1[B-1]/A[(B-2)+2*N];
_5:
  EV[B-1] := A[(B-1)+1*N];
_6:
 end;
goto _9;
_7:
IERR := N+B;
goto _9;
_8:
IERR := 2*N+B;
_9:
if ( IERR <> 0 ) 
 then goto _23;
IERR := 0;
if ( N = 1 ) 
 then goto _23;
for E:=2 to N do
 begin
_10:
  RAB1[E-2] := RAB1[E-1];
 end;
RAB1[N-1] := 0.0;
for H:=1 to N do
 begin
  F := 0;
_11:
  for I:=H to N do
   begin
    if ( I = N ) 
     then goto _13;
    if ( Abs(RAB1[I-1]) <= SYS051*(Abs(EV[I-1])+Abs(EV[I+0])) )
     then goto _13;
_12:
   end;
_13:
  Q := EV[H-1];
  if ( I = H ) 
   then goto _18;
  if ( F = 30 ) 
   then goto _22;
  F := F+1;
  P := (EV[H+0]-Q)/(2.0*RAB1[H-1]);
  if ( Abs(P) > 1.0 ) 
   then R := Abs(P)*Sqrt(1.0+IntPower(1.0/P,2));
  if ( Abs(P) <= 1.0 ) 
   then R := Sqrt(P*P+1.0);
  P := EV[I-1]-Q+RAB1[H-1]/(P+Sign(R,P));
  S := 1.0;
  M := 1.0;
  Q := 0.0;
  K := I-H;
  for J:=1 to K do
   begin
    E := I-J;
    O := S*RAB1[E-1];
    L := M*RAB1[E-1];
    if ( Abs(O) < Abs(P) ) 
     then goto _14;
    M := P/O;
    R := Sqrt(M*M+1.0);
    RAB1[E+0] := O*R;
    S := 1.0/R;
    M := M*S;
    goto _15;
_14:
    S := O/P;
    R := Sqrt(S*S+1.0);
    RAB1[E+0] := P*R;
    M := 1.0/R;
    S := S*M;
_15:
    P := EV[E+0]-Q;
    R := (EV[E-1]-P)*S+2.0*M*L;
    Q := S*R;
    EV[E+0] := P+Q;
    P := M*R-L;
    for G:=1 to N do
     begin
      O := V[(G-1)+(E+0)*N];
      V[(G-1)+(E+0)*N] := S*V[(G-1)+(E-1)*N]+M*O;
      V[(G-1)+(E-1)*N] := M*V[(G-1)+(E-1)*N]-S*O;
_16:
     end;
_17:
   end;
  EV[H-1] := EV[H-1]-Q;
  RAB1[H-1] := P;
  RAB1[I-1] := 0.0;
  goto _11;
_18:
 end;
for J:=2 to N do
 begin
  E := J-1;
  G := E;
  Q := EV[E-1];
  for F:=J to N do
   begin
    if ( EV[F-1] >= Q ) 
     then goto _19;
    G := F;
    Q := EV[F-1];
_19:
   end;
  if ( G = E ) 
   then goto _21;
  EV[G-1] := EV[E-1];
  EV[E-1] := Q;
  for F:=1 to N do
   begin
    Q := V[(F-1)+(E-1)*N];
    V[(F-1)+(E-1)*N] := V[(F-1)+(G-1)*N];
    V[(F-1)+(G-1)*N] := Q;
_20:
   end;
_21:
 end;
goto _23;
_22:
IERR := H;
_23:
if ( IERR <> 0 ) 
 then UTAE10(IERR,N,15);
end;

end.
